#pragma once

#include <complex>
#include <string>

namespace complex{

  template<typename T>
  std::complex<T> operator-(int i,std::complex<T> z){
    return static_cast<T>(i) - z;
  }

  template<typename T>
  std::complex<T> operator-(std::complex<T> z,int i){
    return z - static_cast<T>(i);
  }

  template<typename T>
  std::complex<T> operator+(int i,std::complex<T> z){
    return static_cast<T>(i) + z;
  }

  template<typename T>
  std::complex<T> operator+(std::complex<T> z,int i){
    return z + static_cast<T>(i);
  }

  template<typename T>
  std::complex<T> operator*(int i,std::complex<T> z){
    return static_cast<T>(i) * z;
  }

  template<typename T>
  std::complex<T> operator*(std::complex<T> z,int i){
    return z * static_cast<T>(i);
  }

  template<typename T>
  std::complex<T> operator/(int i,std::complex<T> z){
    return static_cast<T>(i) / z;
  }

  template<typename T>
  std::complex<T> operator/(std::complex<T> z,int i){
    return z / static_cast<T>(i);
  }

  template<typename T>
  struct less{
    bool operator()( std::complex<T> const & lhs, std::complex<T> const & rhs ) const{
      return (lhs.real() < rhs.real()) && (lhs.imag() < rhs.imag());
    }
  };

  template<typename T>
  std::string to_string(std::complex<T> z){
    return "(" + std::to_string(real(z)) + ", " + std::to_string(imag(z)) + ")";
  }
}
