Needs["QQbarThreshold`"];

ZN[i_, mbPS_] := BBbarResidue[i, mbPS, mbPS, "N3LO"];

EN[i_, mbPS_] := BBbarEnergyLevel[i, mbPS, mbPS, "N3LO"];

Rb[s_, mbPS_] := BBbarRRatio[Sqrt[s], mbPS, mbPS, "N3LO"];

Mresonances[n_, mbPS_] := With[
   {
      Nc = 3, eb = eD,
      mbPole = BottomPoleMass[mbPS, mbPS, "N3LO"]
   },
   12*Pi^2*Nc*eb^2/mbPole^2*Sum[
      ZN[i, mbPS]/(2*mbPS + EN[i, mbPS])^(2*n+1),
      {i, 1, 6}
   ]
];

Mcontinuum[n_, mbPS_] := Module[
   {s0, s, x},
   s0 = BBbarThreshold[mbPS, mbPS, "N3LO"]^2;
   s[x_] := s0 + x/(1 - x);
   Return[
      NIntegrate[
         Rb[s[x], mbPS]/(s[x]^(n+1)*(1 - x)^2),
         {x, 0, 1},
         AccuracyGoal -> 5
      ]
   ];
];

M[n_, mbPS_] := 10^(2*n)*(Mresonances[n, mbPS] + Mcontinuum[n, mbPS]);

LoadGrid[GridDirectory <> "bbbar_grid_large.tsv"];
Print[M[10, 4.5322]];
