LaunchKernels[];

Needs["QQbarThreshold`"];
ParallelEvaluate[Needs["QQbarThreshold`"]];
ParallelEvaluate[LoadGrid[GridDirectory <> "ttbar_grid.tsv"]];

XSection[sqrts_, mu_] := With[
   {muWidth = 350, mt = 171.5, width = 1.33},
   TTbarXSection[sqrts, {mu, muWidth}, {mt, width}, "N3LO"]
];

XSectionScaleVariation[sqrts_] := Module[
   {
      muDefault = 80, muMin = 50, muMax = 350,
      xsDefault, xsMin, xsMax, mu
   },
   xsDefault = XSection[sqrts, muDefault];
   xsMin = NMinValue[
      {XSection[sqrts, mu], muMin <= mu <= muMax},
      mu,
      Method -> "SimulatedAnnealing"
   ];
   xsMax = NMaxValue[
      {XSection[sqrts, mu], muMin <= mu <= muMax},
      mu,
      Method -> "SimulatedAnnealing"
   ];
   Return[{sqrts, xsDefault, xsMin, xsMax}];
];

results = ParallelTable[
   XSectionScaleVariation[sqrts],
   {sqrts, 340, 349, 0.2}
];

PrependTo[results, {"sqrt_s", "central", "min", "max"}];
Print[TableForm[results]];
