/**
 * @file
 * @brief ---
 * @author  Andreas Maier <a.maier@tum.de>
 * @version 1.0.1
 *
 * @section LICENSE
 *
 * Copyright 2014 Andreas Maier
 *
 * This file is part of the QCD library.
 *
 * The QCD library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 3 of
 * the License, or (at your option) any later version.
 *
 * The QCD library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the QCD library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 */
#pragma once

#ifndef NDEBUG
#include <set>
#include <iostream>
#endif

namespace QQbar_threshold{
  inline void dprint(){}
  struct ignore { template<typename ...T> ignore(T && ... ) {} };

  template<typename T, typename... Rest>
  inline void dprint(T t, Rest... r){
    ignore{t, r...};
#ifndef NDEBUG
    std::cout << t;
    dprint(r...);
#endif
  }
}
