#ifdef NDEBUG
#undef NDEBUG
#endif

#include <iostream>
#include <cassert>
#include <string>
#include <complex>
#include <cmath>

#include "harmonic_sums.hpp"

static constexpr double ep = 1e-14;

#define TST(name) \
  std::cout << #name << ": "; \
  diff = std::abs(name - 1.0);  \
  std::cout << name; \
  assert(diff < ep); \
  std::cout << " (ok)" << std::endl;

int main(){
  using harmonic_sums::harmonic_sum;
  double diff;
  std::cout << "target precision: " << ep << "\n";

  //std::cout << harmonic_sum<1>::usage << std::endl;
  TST((harmonic_sum<1>(1.0)));
  TST((harmonic_sum<4>(1.0)));
  //std::cout << harmonic_sum<2,1,1,1>(1.0)::usage << std::endl;
  TST((harmonic_sum<1,1>(1.0)));
  TST((harmonic_sum<2,1>(1.0)));
  TST((harmonic_sum<3,1>(1.0)));
  TST((harmonic_sum<3,2>(1.0)));
  TST((harmonic_sum<4,1>(1.0)));
  TST((harmonic_sum<4,2>(1.0)));
  TST((harmonic_sum<5,1>(1.0)));
  TST((harmonic_sum<2,1,1>(1.0)));
  TST((harmonic_sum<2,2,1>(1.0)));
  TST((harmonic_sum<3,1,1>(1.0)));
  TST((harmonic_sum<4,1,1>(1.0)));
  TST((harmonic_sum<2,1,1,1>(1.0)));


}
