#ifdef NDEBUG
#undef NDEBUG
#endif
#include <iostream>

#include "load_grid.hpp"
#include "threshold.hpp"
#include "xsection.hpp"
#include "mass_schemes.hpp"

int main(){
  using namespace QQbar_threshold::pert_order;
  using QQbar_threshold::ttbar_R_ratio;
  using QQbar_threshold::bbbar_R_ratio;
  using QQbar_threshold::PSshift;
  using QQbar_threshold::SM;
  using QQbar_threshold::top_options;

  auto const thr = QQbar_threshold::threshold();
  double constexpr mt = 175.;
  double constexpr mu = 80;
  double constexpr width = 1.4;

  auto opt = top_options();
  opt.ml = 0;
  opt.beyond_QCD = SM::none;
  opt.mass_scheme = {PSshift, 20};

  QQbar_threshold::load_grid("../grids/ttbar_grid.tsv");
  for(order o = LO; o <= N3LO; ++o){
    double thr_top = ttbar_threshold(mu, mt, o, opt);
    double xs1 = ttbar_R_ratio(1.01*thr_top + 1, mu, {mt, width}, o, opt);
    double xs2 = ttbar_R_ratio(1.01*thr + 1, mu, {mt, width}, o, opt);
    std::cout << o << ": " << (xs1-xs2);
    assert(xs1 - xs2 == 0);
    std::cout << " (ok)\n";
  }

}
